 /*---------------------------------------------------------------------------
|                                grebulon.com                                 |
|                    Screen region capture plugin for IrfanView               |
|                                code based on                                |
|       http://www.codeproject.com/KB/gadgets/Screen_Snaper_Gadget.aspx       |
|--------------------------------------+--------------------------------------|
|                                  DCUtility                                  |
|    SolutionName : ScreenSnaperGadget                                        |
|    ProjectName  : Helper                                                    |
|    FileName     : WinCapture.cpp                                            |
|    CreationDate : 2007-03-07                                                |
|    Author       : Dany Cantin                                               |
|    Comments     : dcutility@hotmail.com                                     |
|--------------------------------------+--------------------------------------|
|                             Screen Capture Tool                             |
|                         Windows Vista SideBar Gadget                        |
|--------------------------------------+--------------------------------------|
|                          Copyright  2007 DCUtility                         |
|                              All rights reserved.                           |
 ---------------------------------------------------------------------------*/

#include "stdafx.h"
#include "DrawUtil.h"
#include "math.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//#define BOUND(x,min,max)	((x) < (min) ? (min) : ((x) > (max) ? (max) : (x)))
//#define MIN3(x,y,z)		((x) < (y) ? ((x) < (z) ? (x) : (z)) : ((y) < (z) ? (y) : (z)))
#define GAP(x,y)			((y) > (x) ? (y) - (x) : (x) - (y))
#define GAP_SQR(x,y)		(((y) - (x)) * ((y) - (x)))
#define SIGN(x,y)			((x) > (y) ? 1 : -1)

CDrawUtil::CDrawUtil()
{
	m_desktopSize = CSize(GetSystemMetrics(SM_CXSCREEN), GetSystemMetrics(SM_CYSCREEN));
}

/*
BOOL CDrawUtil::DoTheZoom(CDC* pDCDest, CSize SizeDest, CDC* pDCSrc,
                          CSize SizeSrc, CPoint point, int nZoomFactor,
                          BOOL bDrawCross, int nCrossWidth, BOOL bDesktopPos)
{
    CSize       Zoomed;
    CBitmap     Bitmap;
    CPoint      pt;

    Zoomed.cx = ((SizeDest.cx / nZoomFactor) / 2) + 1;
    Zoomed.cy = ((SizeDest.cy / nZoomFactor) / 2) + 1;

    Bitmap.CreateCompatibleBitmap(pDCSrc, SizeDest.cx, SizeDest.cy);
    CBitmap* pOldBitmap = pDCDest->SelectObject(&Bitmap);

    pt.x = BOUND(point.x, Zoomed.cx, SizeSrc.cx - Zoomed.cx);
    pt.y = BOUND(point.y, Zoomed.cy, SizeSrc.cy - Zoomed.cy);

    pDCDest->SetStretchBltMode(COLORONCOLOR);
    pDCDest->StretchBlt(0, 0, SizeDest.cx, SizeDest.cy,
                  pDCSrc, 
                  pt.x - Zoomed.cx, pt.y - Zoomed.cy,
                  Zoomed.cx*2, Zoomed.cy*2,
                  SRCCOPY);

    if (bDrawCross) {
        pt = CPoint(SizeDest.cx/2, SizeDest.cy/2);
        DrawSreenCross(pDCDest, pt, CSize(SizeDest.cx, SizeDest.cy),
                       nCrossWidth, (bDesktopPos)?TRUE:FALSE);
        pDCDest->SetROP2(R2_NOT);
        pDCDest->Rectangle(pt.x, pt.y, pt.x+nZoomFactor-1, pt.y+nZoomFactor-1);
    }

    pDCDest->SelectObject(pOldBitmap);
    Bitmap.DeleteObject();
    
    return TRUE;
}
*/
BOOL CDrawUtil::DrawSreenCross(CDC* pDC, CPoint pt, CSize Size,
                               int nPenWidth /*= 1*/, BOOL bDesktopPos /*= FALSE*/)
{
    UNREFERENCED_PARAMETER(nPenWidth);

    BOOL bRet;

    bRet  = pDC->PatBlt(0, pt.y, Size.cx, 1, DSTINVERT);
    bRet |= pDC->PatBlt(pt.x, 0, 1, Size.cy, DSTINVERT);

    if (bDesktopPos) {
        CRect  rc(0, 0, pt.x, pt.y);
        bRet |= DrawPosition(pDC, rc, bDesktopPos, HT_START_POS);
    }

    return bRet;
}

BOOL CDrawUtil::DrawFrame(CDC* pDC, CRect rc, BOOL bShowPos /*= TRUE*/, eDrawMode DrawMode /*= DM_RECTANGLE*/,
                          int nPenWidth /*= 1*/, CPoint pt /*= CPoint(0,0)*/)
{
    CPen Pen;
    if (!Pen.CreatePen(PS_INSIDEFRAME, nPenWidth * GetSystemMetrics(SM_CXBORDER), RGB(0,0,0)))
        return FALSE;
    
    CBrush* pBrush = CBrush::FromHandle((HBRUSH)GetStockObject(NULL_BRUSH));
    if (!pBrush)
        return FALSE;
    
    CPen* pOldPen = pDC->SelectObject(&Pen);
    CBrush* pOldBrush = pDC->SelectObject(pBrush);
    
    pDC->SetROP2(R2_NOT);
    
    if (DrawMode == DM_ELLIPSE)
        pDC->Ellipse(rc);
    else if (DrawMode == DM_RECTANGLE)
	{
		// Rectangle draws up to the bottom-right corner (not including)
        pDC->Rectangle(rc.left, rc.top, rc.right + 1, rc.bottom + 1);
	}
    else if (DrawMode == DM_RECTANGLE_ROUND)
        pDC->RoundRect(rc, pt);    

    pDC->SelectObject(pOldBrush);
    pDC->SelectObject(pOldPen);
    
    Pen.DeleteObject();
    pBrush->DeleteObject();

    if (bShowPos)
        return DrawPosition(pDC, rc, FALSE, HT_MARK_RECT);

    return TRUE;
}

BOOL CDrawUtil::DrawMeasure(CDC* pDC, CRect rc, BOOL bLine, BOOL bStraight, BOOL bShowPos /*= TRUE*/, int nPenWidth /*= 1*/)
{
	if (bLine)
	{
		// Draw line after the first point is selected
		CPen PenBlack;
		if (!PenBlack.CreatePen(PS_SOLID /*PS_DOT*/, nPenWidth, RGB(0,0,0)))
			return FALSE;
    
		CPen* pOldPen = pDC->SelectObject(&PenBlack);
    
		pDC->SetROP2(R2_NOT);

		// When measuring in straight lines
		if (bStraight)
		{
			// Calculate the three nearest points: horizontal, vertical and diagonal and their distances
			CPoint p1, p2, p3;
			LONG d1, d2, d3;
			p1.x = rc.left;
			p1.y = rc.bottom;
			d1 = GAP(rc.right, rc.left);
			p2.x = rc.right;
			p2.y = rc.top;
			d2 = GAP(rc.bottom, rc.top);
			p3.x = rc.left + SIGN(rc.right, rc.left) * (GAP(rc.right, rc.left) + GAP(rc.bottom, rc.top)) / 2;
			p3.y = rc.top + SIGN(rc.bottom, rc.top) * (GAP(rc.right, rc.left) + GAP(rc.bottom, rc.top)) / 2;
			d3 = (LONG)(sqrt((p3.x - rc.right) * (p3.x - rc.right) + (p3.y - rc.bottom) * (p3.y - rc.bottom)) + 0.5);
			// Select the closest point
			if (d1 <= d2 && d1 <= d3)
			{
				rc.right = p1.x;
				rc.bottom = p1.y;
			}
			else if (d2 <= d1 && d2 <= d3)
			{
				rc.right = p2.x;
				rc.bottom = p2.y;
			}
			else
			{
				rc.right = p3.x;
				rc.bottom = p3.y;
			}
		}

		pDC->MoveTo(rc.left, rc.top);
		pDC->LineTo(rc.right, rc.bottom);

		pDC->SelectObject(pOldPen);
    
		PenBlack.DeleteObject();
	}

    if (bShowPos)
	{
		CString txt;
		CSize txtSize;
		if (!bLine)
		{
			// Selecting the first point
			txt.Format("%dx%d\r\n"
					   "Left-click to start\r\n"
					   "ESC to cancel",
					   rc.right, rc.bottom);
			txtSize = pDC->GetTextExtent("Left-click to start");
			txtSize.cy *= 3;
		}
		else
		{
			// Selecting the second point
			txt.Format("%d\r\n"
					   "Left-click to end\r\n"
					   "Right-click to restart\r\n"
					   "ESC to cancel",
					   GetRectMeasure(rc));
			txtSize = pDC->GetTextExtent("Right-click to restart");
			txtSize.cy *= 4;
		}

		CRect rcTxt;
		rcTxt.left = rc.right + 20;
		rcTxt.right = rcTxt.left + txtSize.cx;
		rcTxt.top = rc.bottom + 20;
		rcTxt.bottom = rcTxt.top + txtSize.cy;

		if (rcTxt.bottom > m_desktopSize.cy)
		{
			rcTxt.bottom = rc.bottom - 20;
			rcTxt.top = rcTxt.bottom - txtSize.cy;
		}
		if (rcTxt.right > m_desktopSize.cx)
		{
			rcTxt.right = rc.right - 20;
			rcTxt.left = rcTxt.right - txtSize.cx;
		}

		pDC->SetTextColor(RGB(0, 0, 0));
		pDC->SetBkColor(RGB(255, 255, 255));
		pDC->DrawText(txt, rcTxt, DT_NOCLIP | DT_CENTER | DT_TOP);
	}

	return TRUE;
}

BOOL CDrawUtil::DrawColorPick(CDC* pDC, CPoint pt, COLORREF selCol, BOOL bShowPos /*= TRUE*/)
{
    CPen Pen;
    if (!Pen.CreatePen(PS_INSIDEFRAME, 1, RGB(0,0,0)))
        return FALSE;
    
    CBrush BrushPt;
	COLORREF pixCol = pDC->GetPixel(pt);
	bool bHasSelectedColor = selCol != INVALID_COLOR;
	if (!bHasSelectedColor)
		selCol = pixCol;
	if (!BrushPt.CreateSolidBrush(pixCol))
		return FALSE;
    CBrush BrushSel;
	if (!BrushSel.CreateSolidBrush(selCol))
		return FALSE;

    CString txt = "W000,000,000 - #000000W";
    CSize txtSize;
	CRect rc;
    CPen* pOldPen = pDC->SelectObject(&Pen);
    CBrush* pOldBrush = pDC->SelectObject(&BrushSel);

	txtSize = pDC->GetTextExtent(txt);
	txtSize.cy += 6;

	rc.left = pt.x - 10 - txtSize.cx;
	rc.right = rc.left + txtSize.cx;
	rc.top = pt.y + 10;

	if (bHasSelectedColor)
		rc.bottom = rc.top + txtSize.cy;
	else
		rc.bottom = rc.top + txtSize.cy * 2 - 1;

	if (rc.top + 6 * txtSize.cy > m_desktopSize.cy)
	{
		rc.top -= 6 * txtSize.cy + 20;
		rc.bottom -= 6 * txtSize.cy + 20;
	}
	if (rc.left < 0)
	{
		rc.left = pt.x + 30;
		rc.right = rc.left + txtSize.cx;
	}

	pDC->Rectangle(rc);
    if (bShowPos)
	{
        txt.Format("(%d,%d,%d) - #%02x%02x%02x",
				   GetRValue(selCol), GetGValue(selCol), GetBValue(selCol),
				   GetRValue(selCol), GetGValue(selCol), GetBValue(selCol));
		pDC->SetTextColor(RGB(INV_COLOR(GetRValue(selCol)), INV_COLOR(GetGValue(selCol)), INV_COLOR(GetBValue(selCol))));
		pDC->SetBkColor(selCol);
		LONG txtOffset = 3;
		if (!bHasSelectedColor)
			txtOffset += txtSize.cy / 2;
		rc.top += txtOffset;
		pDC->DrawText(txt, rc, DT_NOCLIP | DT_CENTER | DT_TOP);
		rc.top -= txtOffset;
	}

    pDC->SelectObject(&BrushPt);

	if (bHasSelectedColor)
	{
		rc.top = rc.bottom - 1;
		rc.bottom = rc.top + txtSize.cy;
		pDC->Rectangle(rc);

		if (bShowPos)
		{
			txt.Format("(%d,%d,%d) - #%02x%02x%02x",
					   GetRValue(pixCol), GetGValue(pixCol), GetBValue(pixCol),
					   GetRValue(pixCol), GetGValue(pixCol), GetBValue(pixCol));
			pDC->SetTextColor(RGB(INV_COLOR(GetRValue(pixCol)), INV_COLOR(GetGValue(pixCol)), INV_COLOR(GetBValue(pixCol))));
			pDC->SetBkColor(pixCol);
			rc.top += 3;
			pDC->DrawText(txt, rc, DT_NOCLIP | DT_CENTER | DT_TOP);
			rc.top -= 3;
		}
	}

    pDC->SelectObject(pOldBrush);
    pDC->SelectObject(pOldPen);

    Pen.DeleteObject();
    BrushPt.DeleteObject();
	BrushSel.DeleteObject();

    if (bShowPos)
	{
		rc.top = rc.bottom;
		rc.bottom = rc.top + 4 * txtSize.cy;
        txt.Format("%dx%d", pt.x, pt.y);
		txt += "\r\n"
			   "Left-click to select\r\n"
			   "Right-click to end\r\n"
			   "ESC to cancel";
		pDC->SetTextColor(RGB(0, 0, 0));
		pDC->SetBkColor(RGB(255, 255, 255));
		rc.top += 3;
		pDC->DrawText(txt, rc, DT_NOCLIP | DT_CENTER | DT_TOP);
		rc.top -= 3;
	}

    return TRUE;
}

BOOL CDrawUtil::DrawPosition(CDC* pDC, CRect rc, BOOL bDesktopPos /*= FALSE*/, eHelpText HelpText /*= HT_NONE*/)
{
    CString sz;
    CPoint  pt;
    CSize   Size;

	CString szHelp, szWide;
	switch (HelpText)
	{
	case HT_START_POS:
		szHelp = "\r\nClick to start\r\nESC to cancel";
		szWide = "Click to capture"; // On purpose
		break;
	case HT_MARK_RECT:
		szHelp = "\r\nClick to capture\r\nESC to cancel";
		szWide = "Click to capture";
		break;
	}

    if (bDesktopPos) {
        GetCursorPos(&pt);
        sz.Format("%dx%d", pt.x, pt.y);
    }
    else
        sz.Format("%dx%d", rc.Width() + 1, rc.Height() + 1);

	if (!szHelp.IsEmpty())
	{
		sz += /*" - " +*/ szHelp;
		Size = pDC->GetTextExtent(szWide);
		Size.cy *= 3; // the text has 3 lines but GetTextExtent returns only 1 line
	}
	else
	{
		Size = pDC->GetTextExtent(sz);
	}

    pDC->SetTextColor(RGB(255, 255, 255));
    pDC->SetBkColor(RGB(0, 0, 0));

    CPoint center((rc.right + rc.left) / 2, (rc.bottom + rc.top) / 2);
	CRect rcText(center.x - Size.cx / 2, center.y - Size.cy / 2, center.x + Size.cx / 2, center.y + Size.cy / 2);

	CRect rcNorm(rc);
	rcNorm.NormalizeRect();

	if (rcText.top < 0 || rcText.top < rcNorm.top)
	{
		rcText.top = rcNorm.bottom + 5;
		rcText.bottom = rcNorm.bottom + Size.cy + 5;
	}
	if (rcText.left < 0 || rcText.left < rcNorm.left)
	{
		rcText.left = rcNorm.right + 5;
		rcText.right = rcNorm.right + Size.cx + 5;
	}
	if (rcText.bottom > m_desktopSize.cy)
	{
		rcText.top = rcNorm.top - Size.cy - 5;
		rcText.bottom = rcNorm.top - 5;
	}
	if (rcText.right > m_desktopSize.cx)
	{
		rcText.left = rcNorm.left - Size.cx - 5;
		rcText.right = rcNorm.left - 5;
	}
 
	//pDC->DrawFocusRect(rcText);
	return pDC->DrawText(sz, rcText, DT_NOCLIP | DT_CENTER | DT_TOP);
}

CBitmap* CDrawUtil::CopyBitmap(CBitmap* poSourceBmp)
{
    if (!poSourceBmp)
        return NULL;

    BITMAP bmp;
    poSourceBmp->GetBitmap(&bmp);

    CBitmap* poCloneBmp = new CBitmap();
    if (!poCloneBmp->CreateBitmapIndirect(&bmp))
    {
        delete poCloneBmp;
        return NULL;
    }

    CDC oSourceDC, oDestDC;
    if (!oSourceDC.CreateCompatibleDC(NULL) ||
        !oDestDC.CreateCompatibleDC(NULL))
    {
        delete poCloneBmp;
        return NULL;
    }

    CBitmap* poPrevSrcBmp = oSourceDC.SelectObject(poSourceBmp);
    CBitmap* poPrevDestBmp = oDestDC.SelectObject(poCloneBmp);

    oDestDC.BitBlt(0, 0, bmp.bmWidth, bmp.bmHeight, &oSourceDC, 0, 0, SRCCOPY);

    oDestDC.SelectObject(poPrevDestBmp);
    oSourceDC.SelectObject(poPrevSrcBmp);

    return poCloneBmp;
}

CBitmap* CDrawUtil::CopyBitmapFromDC(CDC* pDC, CBitmap* pBmp, CRect rc)
{
	CDC memDC;
	if (!memDC.CreateCompatibleDC(pDC))
		return NULL;

	BITMAP bmp;
	pBmp->GetBitmap(&bmp);
	bmp.bmWidth = rc.Width() + 1;
	bmp.bmHeight = rc.Height() + 1;

	CBitmap *pResultBitmap = new CBitmap();
	if (!pResultBitmap->CreateBitmapIndirect(&bmp))
	{
		delete pResultBitmap;
		memDC.DeleteDC();
		return NULL;
	}

	CBitmap *pOldMemBitmap = memDC.SelectObject(pResultBitmap);
	memDC.BitBlt(0, 0, bmp.bmWidth, bmp.bmHeight, pDC, rc.left, rc.top, SRCCOPY);
	memDC.SelectObject(pOldMemBitmap);
	memDC.DeleteDC();
	return pResultBitmap;
}

/*static*/ LONG CDrawUtil::GetRectMeasure(CRect &rc)
{
	LONG dx = GAP(rc.right, rc.left);
	LONG dy = GAP(rc.bottom, rc.top);
	if (dx == 0)
		return dy;
	if (dy == 0)
		return dx;
	return (LONG)(sqrt((double)(dx * dx + dy * dy)) + 0.5);
}
