 /*---------------------------------------------------------------------------
|                                grebulon.com                                 |
|                    Screen region capture plugin for IrfanView               |
|                                code based on                                |
|       http://www.codeproject.com/KB/gadgets/Screen_Snaper_Gadget.aspx       |
|--------------------------------------+--------------------------------------|
|                                  DCUtility                                  |
|    SolutionName : ScreenSnaperGadget                                        |
|    ProjectName  : Helper                                                    |
|    FileName     : WinCapture.cpp                                            |
|    CreationDate : 2007-03-07                                                |
|    Author       : Dany Cantin                                               |
|    Comments     : dcutility@hotmail.com                                     |
|--------------------------------------+--------------------------------------|
|                             Screen Capture Tool                             |
|                         Windows Vista SideBar Gadget                        |
|--------------------------------------+--------------------------------------|
|                          Copyright  2007 DCUtility                         |
|                              All rights reserved.                           |
 ---------------------------------------------------------------------------*/
#pragma once

#define INV_COLOR(x) (((x) < 0x60 || (x) >= 0xA0) ? (0xFF - (x)) : ((x) < 0x80 ? (x) - 0x60 : (x) + 0x60))

class CDrawUtil  
{
public:
    CDrawUtil();
    ~CDrawUtil() {}

    enum eDrawMode { DM_NONE = -1, DM_ELLIPSE, DM_RECTANGLE, DM_RECTANGLE_ROUND };
	enum eHelpText { HT_NONE = -1, HT_START_POS, HT_MARK_RECT };

    BOOL     DrawSreenCross(CDC* pDC,
                            CPoint pt,
                            CSize Size,
                            int nPenWidth = 1,
                            BOOL bDesktopPos = FALSE);

    BOOL     DrawFrame(CDC* pDC,
                       CRect rc,
                       BOOL bShowPos = TRUE,
                       eDrawMode DrawMode = DM_RECTANGLE,
                       int nPenWidth = 1,
                       CPoint pt = CPoint(0,0));

	BOOL	DrawMeasure(CDC* pDC,
                       CRect rc,
					   BOOL bLine,
					   BOOL bStraight,
                       BOOL bShowPos = TRUE,
					   int nPenWidth = 1);

	BOOL	DrawColorPick(CDC* pDC,
						CPoint pt,
						COLORREF selectedColor,
						BOOL bShowPos = TRUE);

    BOOL    DrawPosition(CDC* pDC,
                          CRect rc,
                          BOOL bDesktopPos = FALSE,
						  eHelpText HelpText = HT_NONE);
/*
    BOOL     DoTheZoom(CDC* pDCDest,
                       CSize SizeDest,
                       CDC* pDCSrc,
                       CSize SizeSrc,
                       CPoint point,
                       int nZoomFactor,
                       BOOL bDrawCross = TRUE,
                       int nCrossWidth = 1,
                       BOOL bDesktopPos = FALSE);
*/
    CBitmap* CopyBitmap(CBitmap* poSourceBmp);
    CBitmap* CopyBitmapFromDC(CDC* pDC, CBitmap* pBmp, CRect rc);

	static LONG GetRectMeasure(CRect &rc);

private:
    CSize m_desktopSize;
};
