 /*---------------------------------------------------------------------------
|                                grebulon.com                                 |
|                    Screen region capture plugin for IrfanView               |
|                                code based on                                |
|       http://www.codeproject.com/KB/gadgets/Screen_Snaper_Gadget.aspx       |
|--------------------------------------+--------------------------------------|
|                                  DCUtility                                  |
|    SolutionName : ScreenSnaperGadget                                        |
|    ProjectName  : Helper                                                    |
|    FileName     : WinCapture.cpp                                            |
|    CreationDate : 2007-03-07                                                |
|    Author       : Dany Cantin                                               |
|    Comments     : dcutility@hotmail.com                                     |
|--------------------------------------+--------------------------------------|
|                             Screen Capture Tool                             |
|                         Windows Vista SideBar Gadget                        |
|--------------------------------------+--------------------------------------|
|                          Copyright  2007 DCUtility                         |
|                              All rights reserved.                           |
 ---------------------------------------------------------------------------*/

#include "stdafx.h"
#include "resource.h"
#include "Helper.h"
#include "DrawUtil.h"
#include "WinCapture.h"
#include "MemDC.h"
//#include "multimon.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define PIXEL_INCREMENTAL_MOVE  10
#define RECT_ROUND_WIDTH		25

CWinCapture::CWinCapture(CWnd* pParent /*=NULL*/)
    : CDialog(CWinCapture::IDD, pParent)
{
    //{{AFX_DATA_INIT(CWinCapture)
    //}}AFX_DATA_INIT

    m_CaptureType           = CT_REGION;

    //m_CMWDrawMode           = CDrawUtil::DM_RECTANGLE;
    //m_bCMWShowPos           = TRUE;
    //m_nCMWPenWidth          = 3;
    //m_nCMWRectRoundWidth    = 25;
    //m_CMRDrawMode           = CDrawUtil::DM_RECTANGLE;
    //m_bCMRShowPos           = TRUE;
    //m_nCMRPenWidth          = 1;
    //m_nCMRRectRoundWidth    = 25;
    //m_Backcolor             = RGB(255, 0, 255);
    //m_bShowHelp             = FALSE;
    m_pOldMemBitmap         = NULL;
    m_FirstDownClick        = FALSE;
    m_bEndSelection         = FALSE;
    m_ShiftKeyPressed       = FALSE;
    m_bRestoreCursorArrow   = FALSE;
    m_bShowCursor           = TRUE;
	m_pResultBitmap			= NULL;

	m_pickedColor = INVALID_COLOR;
}

BOOL CWinCapture::DestroyWindow() 
{
    if (m_pOldMemBitmap)
        m_MemDC.SelectObject(m_pOldMemBitmap);
	m_MemDC.DeleteDC();

    return CDialog::DestroyWindow();
}

void CWinCapture::DoDataExchange(CDataExchange* pDX)
{
    CDialog::DoDataExchange(pDX);
    //{{AFX_DATA_MAP(CWinCapture)
    //}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CWinCapture, CDialog)
    //{{AFX_MSG_MAP(CWinCapture)
    ON_WM_ERASEBKGND()
    ON_WM_MOUSEMOVE()
    ON_WM_SETCURSOR()
    ON_WM_LBUTTONDOWN()
    ON_WM_RBUTTONDOWN()
    //}}AFX_MSG_MAP
END_MESSAGE_MAP()

BOOL CWinCapture::OnInitDialog() 
{
    CDialog::OnInitDialog();
    
	//ShowWindow(SW_SHOWMINIMIZED);
	//ShowWindow(SW_HIDE);
    m_DesktopSize = CSize(GetSystemMetrics(SM_CXSCREEN), GetSystemMetrics(SM_CYSCREEN));
/*
	CRect Rect;
	Rect.left = GetSystemMetrics(SM_XVIRTUALSCREEN);
	Rect.top = GetSystemMetrics(SM_YVIRTUALSCREEN);
	Rect.right = Rect.left + GetSystemMetrics(SM_CXVIRTUALSCREEN);
	Rect.bottom = Rect.top + GetSystemMetrics(SM_CYVIRTUALSCREEN);
*/
    CWindowDC dc(NULL);
    m_MemBitmap.CreateCompatibleBitmap(&dc, m_DesktopSize.cx, m_DesktopSize.cy);
    m_MemDC.CreateCompatibleDC(&dc);
    m_pOldMemBitmap = m_MemDC.SelectObject(&m_MemBitmap);
    m_MemDC.BitBlt(0, 0, m_DesktopSize.cx, m_DesktopSize.cy, &dc, 0, 0, SRCCOPY);

    if (m_CaptureType == CT_DESKTOP)
	{
        m_rcSnap.SetRect(0, 0, m_DesktopSize.cx, m_DesktopSize.cy);
        OnOK();
    }
    else
	{
		m_pickedColor = INVALID_COLOR;
        SetCursorPos(m_DesktopSize.cx / 2, m_DesktopSize.cy / 2);
        SetWindowPos(&wndTopMost, 0,0, m_DesktopSize.cx, m_DesktopSize.cy, SWP_SHOWWINDOW);    
    }

    return TRUE;
}

BOOL CWinCapture::OnEraseBkgnd(CDC* pDC) 
{
    SetWindowPos(&wndTopMost, 0,0, m_DesktopSize.cx, m_DesktopSize.cy, SWP_SHOWWINDOW);    

    if (m_bEndSelection || m_CaptureType == CT_DESKTOP)
	{
        pDC->BitBlt(0, 0, m_DesktopSize.cx, m_DesktopSize.cy, &m_MemDC, 0, 0, SRCCOPY);    
		m_pResultBitmap = m_DrawUtil.CopyBitmapFromDC(&m_MemDC, &m_MemBitmap, m_rcSnap);
        OnOK();
    }

	if (m_CaptureType == CT_REGION)
	{
        if (!m_FirstDownClick)
		{
            pDC->BitBlt(0, 0, m_DesktopSize.cx, m_DesktopSize.cy, &m_MemDC, 0, 0, SRCCOPY);    
            m_DrawUtil.DrawSreenCross(pDC, m_CurrentPoint, m_DesktopSize, 1, TRUE);
        }
        else
		{
            CMemDC MemDC(pDC);
            MemDC.BitBlt(0, 0, m_DesktopSize.cx, m_DesktopSize.cy, &m_MemDC, 0, 0, SRCCOPY);    
            m_DrawUtil.DrawFrame(&MemDC, m_rcSnap, TRUE, CDrawUtil::DM_RECTANGLE, 1,
                                 CPoint(RECT_ROUND_WIDTH, RECT_ROUND_WIDTH));
        }    
    }
	else if (m_CaptureType == CT_COLOR_PICK)
	{
        pDC->BitBlt(0, 0, m_DesktopSize.cx, m_DesktopSize.cy, &m_MemDC, 0, 0, SRCCOPY);    
		m_DrawUtil.DrawColorPick(pDC, m_CurrentPoint, m_pickedColor, TRUE);
	}
	else if (m_CaptureType == CT_MEASURE)
	{
        if (!m_FirstDownClick)
		{
            pDC->BitBlt(0, 0, m_DesktopSize.cx, m_DesktopSize.cy, &m_MemDC, 0, 0, SRCCOPY);    
			CRect rc(0, 0, m_CurrentPoint.x, m_CurrentPoint.y);
            m_DrawUtil.DrawMeasure(pDC, rc, m_FirstDownClick, m_ShiftKeyPressed, 1);
        }
        else
		{
            CMemDC MemDC(pDC);
            MemDC.BitBlt(0, 0, m_DesktopSize.cx, m_DesktopSize.cy, &m_MemDC, 0, 0, SRCCOPY);    
            m_DrawUtil.DrawMeasure(&MemDC, m_rcSnap, m_FirstDownClick, m_ShiftKeyPressed, 1);
        }    
	}

    return TRUE;
}

BOOL CWinCapture::OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message) 
{
    UNREFERENCED_PARAMETER(pWnd);
    UNREFERENCED_PARAMETER(nHitTest);
    UNREFERENCED_PARAMETER(message);
    
    if (m_bShowCursor || m_bRestoreCursorArrow)
	{
        if (m_bRestoreCursorArrow)
		{
            SetCursor(LoadCursor(NULL, IDC_ARROW));
        }
        else if (m_CaptureType == CT_REGION)
		{
            if (!m_FirstDownClick)
                SetCursor(AfxGetApp()->LoadCursor(IDC_CURSOR_CROSS));
            else
                SetCursor(AfxGetApp()->LoadCursor(IDC_CURSOR_TRACKER));
        }
		else if (m_CaptureType == CT_COLOR_PICK)
		{
			SetCursor(AfxGetApp()->LoadCursor(IDC_CURSOR_COLOR_PICK));
		}
		else if (m_CaptureType == CT_MEASURE)
		{
            if (!m_FirstDownClick)
                SetCursor(AfxGetApp()->LoadCursor(IDC_CURSOR_MEASURE));
            else
                SetCursor(AfxGetApp()->LoadCursor(IDC_CURSOR_MEASURE_DRAG));
		}
    }
    else
        SetCursor(NULL);

    return TRUE;
}

void CWinCapture::OnLButtonDown(UINT nFlags, CPoint point) 
{
    if (m_CaptureType == CT_REGION)
	{
        m_FirstDownClick = !m_FirstDownClick;

        if (!m_FirstDownClick)
		{
            m_bEndSelection = TRUE;
            Invalidate();
        }
        else
		{
            m_LastPoint = point;
        }
    }
	else if (m_CaptureType == CT_COLOR_PICK)
	{
		m_pickedColor = m_MemDC.GetPixel(point);
        Invalidate();
	}
	else if (m_CaptureType == CT_MEASURE)
	{
        m_FirstDownClick = !m_FirstDownClick;

        if (!m_FirstDownClick)
		{
            m_bEndSelection = TRUE;
            Invalidate();
        }
        else
		{
            m_LastPoint = point;
        }
	}

    CDialog::OnLButtonDown(nFlags, point);
}

void CWinCapture::OnRButtonDown(UINT nFlags, CPoint point) 
{
    if (m_CaptureType == CT_REGION)
	{
        m_bEndSelection = TRUE;
        Invalidate();
	}
	else if (m_CaptureType == CT_COLOR_PICK)
	{
        m_bEndSelection = TRUE;
        Invalidate();
	}
	else if (m_CaptureType == CT_MEASURE)
	{
		m_FirstDownClick = FALSE;
        Invalidate();
	}
}

void CWinCapture::OnMouseMove(UINT nFlags, CPoint point) 
{ 
    SetWindowPos(&wndTopMost, 0,0, m_DesktopSize.cx, m_DesktopSize.cy, SWP_SHOWWINDOW);    

	if (m_CaptureType == CT_REGION)
	{
        if (m_FirstDownClick)
		{
            m_rcSnap.SetRect(m_LastPoint.x, m_LastPoint.y, point.x, point.y);
            m_rcSnap.NormalizeRect();
        }
        Invalidate();
    }
	else if (m_CaptureType == CT_COLOR_PICK)
	{
        Invalidate();
	}
	else if (m_CaptureType == CT_MEASURE)
	{
        if (m_FirstDownClick)
		{
            m_rcSnap.SetRect(m_LastPoint.x, m_LastPoint.y, point.x, point.y);
        }
        Invalidate();
	}
    
    m_CurrentPoint = point;

    CDialog::OnMouseMove(nFlags, point);
}

CBitmap* CWinCapture::GetSnapBitmap()
{
    if (m_rcSnap.IsRectEmpty())
        return NULL;

/*
	char buf[256];
	sprintf(buf,"%d,%d - %d, %d",m_rcSnap.left,m_rcSnap.top,m_rcSnap.right,m_rcSnap.bottom);
	::MessageBox(0,buf,"",0);
*/

    if (m_CaptureType == CT_DESKTOP) {
        return m_DrawUtil.CopyBitmap(&m_MemBitmap);
    }

	if (m_pResultBitmap)
	{
		CBitmap *pBmpRes = m_pResultBitmap;
		m_pResultBitmap = NULL;
	    return pBmpRes;
	}

    return NULL;
}

LONG CWinCapture::GetMeasure()
{
	return CDrawUtil::GetRectMeasure(m_rcSnap);
}

BOOL CWinCapture::PreTranslateMessage(MSG* pMsg) 
{
    if(pMsg->message == WM_KEYDOWN)
	{
        CPoint pt = m_CurrentPoint;

        switch (pMsg->wParam)
		{
        case VK_RETURN:
            return TRUE;
            break;
         case VK_SPACE:
            OnLButtonDown(MK_LBUTTON, m_CurrentPoint);
            break;
        case VK_UP:
            pt.y -= (m_ShiftKeyPressed)?PIXEL_INCREMENTAL_MOVE:1;
            SetCursorPos(pt.x, pt.y);
            OnMouseMove(0, pt);
            break;
        case VK_DOWN:
            pt.y += (m_ShiftKeyPressed)?PIXEL_INCREMENTAL_MOVE:1;
            SetCursorPos(pt.x, pt.y);
            OnMouseMove(0, pt);
            break;
        case VK_LEFT:
            pt.x -= (m_ShiftKeyPressed)?PIXEL_INCREMENTAL_MOVE:1;
            SetCursorPos(pt.x, pt.y);
            OnMouseMove(0, pt);
            break;
        case VK_RIGHT:
            pt.x += (m_ShiftKeyPressed)?PIXEL_INCREMENTAL_MOVE:1;
            SetCursorPos(pt.x, pt.y);
            OnMouseMove(0, pt);
            break;
        case VK_SHIFT:
            m_ShiftKeyPressed = TRUE;
            break;
        }
    }
    else if(pMsg->message == WM_KEYUP) {

        switch (pMsg->wParam) {
        case VK_SHIFT:
            m_ShiftKeyPressed = FALSE;
            break;
        }        
    }

    return CDialog::PreTranslateMessage(pMsg);
}

/*
void CWinCapture::ShowArrowCursor(BOOL bShowArrow, CPoint pt)
{
    m_bRestoreCursorArrow = bShowArrow;
    if (pt != CPoint(-1, -1))
	{
        SetCursorPos(m_CurrentPoint.x+pt.x , m_CurrentPoint.y+pt.y);
    }
}
*/
