 /*---------------------------------------------------------------------------
|                                grebulon.com                                 |
|                    Screen region capture plugin for IrfanView               |
|                                code based on                                |
|       http://www.codeproject.com/KB/gadgets/Screen_Snaper_Gadget.aspx       |
|--------------------------------------+--------------------------------------|
|                                  DCUtility                                  |
|    SolutionName : ScreenSnaperGadget                                        |
|    ProjectName  : Helper                                                    |
|    FileName     : WinCapture.cpp                                            |
|    CreationDate : 2007-03-07                                                |
|    Author       : Dany Cantin                                               |
|    Comments     : dcutility@hotmail.com                                     |
|--------------------------------------+--------------------------------------|
|                             Screen Capture Tool                             |
|                         Windows Vista SideBar Gadget                        |
|--------------------------------------+--------------------------------------|
|                          Copyright  2007 DCUtility                         |
|                              All rights reserved.                           |
 ---------------------------------------------------------------------------*/
#pragma once

class CWinCapture : public CDialog
{
public:
    CWinCapture(CWnd* pParent = NULL);

    //{{AFX_DATA(CWinCapture)
    enum { IDD = IDD_DIALOG_SNAP };
    //}}AFX_DATA

private:
    CDrawUtil            m_DrawUtil;
    eSnapType            m_CaptureType;
    //CDrawUtil::eDrawMode m_CMWDrawMode;
    //BOOL                 m_bCMWShowPos;
    //int                  m_nCMWPenWidth;
    //int                  m_nCMWRectRoundWidth;
    //CDrawUtil::eDrawMode m_CMRDrawMode;
    //BOOL                 m_bCMRShowPos;
    //int                  m_nCMRPenWidth;
    //int                  m_nCMRRectRoundWidth;
    //COLORREF             m_Backcolor;
    //BOOL                 m_bShowHelp;
    CSize                m_DesktopSize;
    CDC                  m_MemDC;
    CBitmap              m_MemBitmap;
    CBitmap*             m_pOldMemBitmap;
    CRect                m_rcSnap;
    CPoint               m_LastPoint;
    CPoint               m_CurrentPoint;
    BOOL                 m_FirstDownClick;
    BOOL                 m_bEndSelection;
    BOOL                 m_ShiftKeyPressed;
    BOOL                 m_bRestoreCursorArrow;
    BOOL                 m_bShowCursor;
	COLORREF			 m_pickedColor;

    CBitmap*             m_pResultBitmap;

public:
    void     SetCaptureMode(eSnapType CaptureType)	{m_CaptureType = CaptureType;}
    CBitmap* GetSnapBitmap();
	COLORREF GetPickedColor()						{return m_pickedColor;}
	LONG	 GetMeasure();

private:
    //void     ShowArrowCursor(BOOL bShowArrow, CPoint pt = CPoint(0, 0));

    //{{AFX_VIRTUAL(CWinCapture)
    public:
    virtual BOOL PreTranslateMessage(MSG* pMsg);
    virtual BOOL DestroyWindow();
    protected:
    virtual void DoDataExchange(CDataExchange* pDX);
    //}}AFX_VIRTUAL

protected:
    //{{AFX_MSG(CWinCapture)
    virtual BOOL OnInitDialog();
    afx_msg BOOL OnEraseBkgnd(CDC* pDC);
    afx_msg void OnMouseMove(UINT nFlags, CPoint point);
    afx_msg BOOL OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message);
    afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
    afx_msg void OnRButtonDown(UINT nFlags, CPoint point);
    //}}AFX_MSG
    DECLARE_MESSAGE_MAP()
};
