// IViewCaptureCompanion.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "IViewCaptureCompanion.h"
#include "SystemTray.h"
#include "IViewCaptureDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// IViewCaptureApp

BEGIN_MESSAGE_MAP(IViewCaptureApp, CWinApp)
	//{{AFX_MSG_MAP(IViewCaptureApp)
	//}}AFX_MSG
	ON_COMMAND(ID_HELP, CWinApp::OnHelp)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// IViewCaptureApp construction

IViewCaptureApp::IViewCaptureApp()
{
}

/////////////////////////////////////////////////////////////////////////////
// The one and only IViewCaptureApp object

IViewCaptureApp theApp;

/////////////////////////////////////////////////////////////////////////////
// IViewCaptureApp initialization

BOOL IViewCaptureApp::InitInstance()
{
	// Standard initialization

	// Change the registry key under which our settings are stored.
	// TODO: You should modify this string to be something appropriate
	// such as the name of your company or organization.
	SetRegistryKey(_T("Grebulon"));

#ifdef _AFXDLL
	Enable3dControls();			// Call this when using MFC in a shared DLL
#else
	Enable3dControlsStatic();	// Call this when linking to MFC statically
#endif

	// Only one instance of the application can run on a single computer.
	HANDLE hAllowOnlyOne = ::CreateEvent(NULL, FALSE, FALSE, "__grebulon.com_iview_capture_singleton");
	if (hAllowOnlyOne && ::GetLastError() == ERROR_ALREADY_EXISTS)
	{
		::MessageBox(0, "IrfanView Capture Companion is already running","IrfanView Capture Companion", MB_OK | MB_ICONERROR | MB_SYSTEMMODAL);
		::CloseHandle(hAllowOnlyOne);
		return FALSE;
	}

	IViewCaptureDlg dlg;
	m_pMainWnd = &dlg;
	int nResponse = dlg.DoModal();
	if (nResponse == IDOK)
	{
	}
	else if (nResponse == IDCANCEL)
	{
	}

	::CloseHandle(hAllowOnlyOne);

	// Since the dialog has been closed, return FALSE so that we exit the
	//  application, rather than start the application's message pump.
	return FALSE;
}
