// IViewCaptureDlg.cpp : implementation file
//

#include "stdafx.h"
#include "IViewCaptureCompanion.h"
#include "SystemTray.h"
#include "IViewCaptureDlg.h"
#include "../Helper/stdafx.h"
#include "../Helper/version.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define WM_ICON_NOTIFY	(WM_USER + 10)

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	CString	m_nameAndVersion;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	m_nameAndVersion = "IrfanView Capture Companion Version "VERSION_STR;
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	DDX_Text(pDX, IDC_NAME_AND_VER, m_nameAndVersion);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// Keyboard hook

HHOOK g_keyboardHook = NULL;
#define IS_DOWN(x) ((bool)((x & 0x8000) != 0))

LRESULT CALLBACK KeyboardProc(int nCode, WPARAM wParam, LPARAM lParam)
{
	if (nCode == HC_ACTION && wParam == WM_KEYUP)
    {
		KBDLLHOOKSTRUCT *pvk = (KBDLLHOOKSTRUCT *)lParam;
		if (pvk->vkCode == VK_SNAPSHOT)
		{
			SHORT isShift = GetKeyState(VK_SHIFT);
			SHORT isCtrl = GetKeyState(VK_CONTROL);
			if (IS_DOWN(isCtrl) && !IS_DOWN(isShift))
				AfxGetApp()->GetMainWnd()->PostMessage(WM_COMMAND, ID_MEASURE, 0);
			else if (IS_DOWN(isShift) && !IS_DOWN(isCtrl))
				AfxGetApp()->GetMainWnd()->PostMessage(WM_COMMAND, ID_COLOR_PICK, 0);
			else if (!IS_DOWN(isShift) && !IS_DOWN(isCtrl))
				AfxGetApp()->GetMainWnd()->PostMessage(WM_COMMAND, ID_SNAP_REGION, 0);
		}
    }

    return CallNextHookEx(g_keyboardHook, nCode, wParam, lParam);
}

/////////////////////////////////////////////////////////////////////////////
// IViewCaptureDlg dialog

IViewCaptureDlg::IViewCaptureDlg(CWnd* pParent /*=NULL*/)
	: CDialog(IViewCaptureDlg::IDD, pParent)
{
	m_openInIview = TRUE;
	m_iviewPath =  _T("i_view32.exe");
	//{{AFX_DATA_INIT(IViewCaptureDlg)
	m_bOpenInIview = m_openInIview;
	m_strIviewPath = m_iviewPath;
	//}}AFX_DATA_INIT
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void IViewCaptureDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(IViewCaptureDlg)
	DDX_Control(pDX, IDC_SETTING_OPEN_IN_IVIEW, m_radioSettingOpenInIview);
	DDX_Control(pDX, IDC_SETTING_IVIEW_PATH, m_editSettingPath);
	DDX_Control(pDX, IDC_SETTING_BROWSE, m_btnSettingBrowse);
	DDX_Check(pDX, IDC_SETTING_OPEN_IN_IVIEW, m_bOpenInIview);
	DDX_Text(pDX, IDC_SETTING_IVIEW_PATH, m_strIviewPath);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(IViewCaptureDlg, CDialog)
	//{{AFX_MSG_MAP(IViewCaptureDlg)
	ON_WM_DESTROY()
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_COMMAND(ID_SNAP_DESKTOP, OnSnapDesktop)
	ON_COMMAND(ID_SNAP_WINDOW, OnSnapWindow)
	ON_COMMAND(ID_SNAP_REGION, OnSnapRegion)
	ON_COMMAND(ID_MEASURE, OnMeasure)
	ON_COMMAND(ID_COLOR_PICK, OnColorPick)
	ON_COMMAND(ID_SETTINGS, OnSettings)
	ON_COMMAND(ID_APP_ABOUT, OnAbout)
	ON_COMMAND(ID_APP_EXIT, OnExit)
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_SETTING_BROWSE, OnSettingBrowse)
	ON_BN_CLICKED(IDC_SETTING_OPEN_IN_IVIEW, OnSettingOpenInIview)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// IViewCaptureDlg message handlers

BOOL IViewCaptureDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// Create the tray icon
	if (!m_TrayIcon.Create(NULL,                            // Parent window
                           WM_ICON_NOTIFY,                  // Icon notify message to use
                           AfxGetAppName(),					// tooltip
                           AfxGetApp()->LoadIcon(IDI_SMALL_CAMERA),
                           IDR_POPUP_MENU))                 // ID of tray icon
	{
		MessageBox("Failed to create tray icon");
		return -1;
	}
	m_TrayIcon.SetMenuDefaultItem(0, TRUE);

	ShowWindow(SW_SHOWMINIMIZED);
	PostMessage(WM_SYSCOMMAND, SC_MINIMIZE, 0);
	//ShowWindow(SW_HIDE);

	g_keyboardHook = SetWindowsHookEx(WH_KEYBOARD_LL, (HOOKPROC)KeyboardProc, AfxGetInstanceHandle(), 0);

	m_openInIview = AfxGetApp()->GetProfileInt("Settings", "OpenInIview", 1);
	m_iviewPath = AfxGetApp()->GetProfileString("Settings", "IviewPath", "i_view32.exe");
	m_strIviewPath = m_iviewPath;
	m_bOpenInIview = m_openInIview;
	m_editSettingPath.EnableWindow(m_openInIview ? TRUE : FALSE);
	UpdateData(FALSE);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void IViewCaptureDlg::OnDestroy() 
{
	if (g_keyboardHook != NULL)
		UnhookWindowsHookEx(g_keyboardHook);

	// If the about dialog is open, close it
	CDialog::OnDestroy();
}

void IViewCaptureDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else if (nID == SC_MINIMIZE || nID == SC_CLOSE)
	{
		ShowWindow(SW_MINIMIZE);
		ShowWindow(SW_HIDE);

		// Set DWL_MSGRESULT to 0 to say that we handled WM_SYSCOMMAND
		SetWindowLong(GetSafeHwnd(), DWL_MSGRESULT, 0);
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void IViewCaptureDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

HCURSOR IViewCaptureDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void IViewCaptureDlg::OnAbout()
{
	CAboutDlg dlgAbout;
	dlgAbout.DoModal();
}

void IViewCaptureDlg::OnExit()
{
	EndDialog(0);
}

void IViewCaptureDlg::OnSnapDesktop() 
{
//    HBITMAP hImage = GetSnapType(CT_DESKTOP);
//    UpdateImage(hImage);
}

void IViewCaptureDlg::OnSnapWindow() 
{
//    HBITMAP hImage = GetSnapType(CT_WINDOW);
//    UpdateImage(hImage);
}

void IViewCaptureDlg::OnSnapRegion() 
{
	//HANDLE hDib = GetRegionCapture(0, NULL);
	HANDLE hDib = GetRegionCapture(CT_REGION, NULL);
    UpdateDib(hDib);
}

void IViewCaptureDlg::OnMeasure()
{
	//LONG measure = GetMeasure(0, NULL);
	LONG measure = (LONG)GetRegionCapture(CT_MEASURE, NULL);
	if (measure != -1)
	{
		char buff[128];
		sprintf(buff, "length: %d", (int)(measure + 0.5));
		MessageBox(buff);
	}
}

void IViewCaptureDlg::OnColorPick()
{
	//COLORREF color = GetColorPick(0, NULL);
	COLORREF color = (COLORREF)GetRegionCapture(CT_COLOR_PICK, NULL);
	if (color != INVALID_COLOR)
	{
		char buff[128];
		sprintf(buff, "(R,G,B) = (%d,%d,%d)", GetRValue(color), GetGValue(color), GetBValue(color));
		MessageBox(buff);
	}
}

HBITMAP IViewCaptureDlg::CopyBitmap(HBITMAP hbm)
{
	HDC hdcSrc, hdcDst;
    HBITMAP hbmOld, hbmOld2, hbmNew = NULL;
    BITMAP bm;

    hdcSrc = CreateCompatibleDC(NULL);
	if (hdcSrc == NULL)
		goto exit_CopyBitmap_1;
    hdcDst = CreateCompatibleDC(NULL);
	if (hdcDst == NULL)
		goto exit_CopyBitmap_2;
    if (GetObject(hbm, sizeof(bm), &bm) == 0)
		goto exit_CopyBitmap_3;
    hbmOld = (HBITMAP)SelectObject(hdcSrc, hbm);
	if (hbmOld == NULL)
		goto exit_CopyBitmap_3;
    hbmNew = CreateBitmap(bm.bmWidth, bm.bmHeight, bm.bmPlanes, bm.bmBitsPixel, NULL);
	if (hbmNew == NULL)
		goto exit_CopyBitmap_4;
    hbmOld2 = (HBITMAP)SelectObject(hdcDst, hbmNew);
    BitBlt(hdcDst, 0, 0, bm.bmWidth, bm.bmHeight, hdcSrc, 0, 0, SRCCOPY);

exit_CopyBitmap_4:
    SelectObject(hdcSrc, hbmOld);
exit_CopyBitmap_3:
    DeleteDC(hdcDst);
exit_CopyBitmap_2:
    DeleteDC(hdcSrc);
exit_CopyBitmap_1:
    return hbmNew;
}

void IViewCaptureDlg::UpdateImage(HBITMAP hImage)
{
	if (!hImage)    
		return;  
	if (!OpenClipboard())
	{
		MessageBox("Failed to open the clipboard");
		return;
	}

	EmptyClipboard();
	// Need to copy because the ownership is passed to the clipboard
	HBITMAP hImageCopy = CopyBitmap(hImage);
	HANDLE hSysImage = NULL;
	if (hImageCopy != NULL)
	{
		hSysImage = SetClipboardData(CF_BITMAP, hImageCopy);
		if (hSysImage != NULL)
		{
			if (m_openInIview && !m_iviewPath.IsEmpty())
			{
				STARTUPINFO startupInfo;
				memset(&startupInfo, 0, sizeof(startupInfo));
				startupInfo.cb = sizeof(startupInfo);
				PROCESS_INFORMATION processInformation;
				CString cmdLine = "\"";
				cmdLine += m_iviewPath;
				cmdLine += "\" /clippaste";
				if (CreateProcess(NULL, (LPSTR)(LPCTSTR)cmdLine, NULL, NULL, FALSE, 0, NULL,
								  NULL, &startupInfo, &processInformation) == 0)
					MessageBox("Failed to launch IrfanView");
			}
		}
		else
			MessageBox("Failed to copy the region to the clipboard");
	}
	CloseClipboard();
}

void IViewCaptureDlg::UpdateDib(HANDLE hDib)
{
	if (!hDib)    
		return;  
	if (!OpenClipboard())
	{
		MessageBox("Failed to open the clipboard");
		return;
	}

	EmptyClipboard();

/*	// Convert the DIB into bitmap
	HBITMAP hImageCopy = NULL;
    HDC hdc = CreateCompatibleDC(NULL);
	if (hdc)
	{
		BITMAPINFO *pBmi = (BITMAPINFO *)hDib;
		BYTE *pBits = (BYTE *)hDib + sizeof(BITMAPINFO);
		if (pBmi->bmiHeader.biClrUsed > 0)
			pBits += (pBmi->bmiHeader.biClrUsed - 1) * sizeof(RGBQUAD);
		int height = pBmi->bmiHeader.biHeight > 0 ? pBmi->bmiHeader.biHeight : -pBmi->bmiHeader.biHeight;
		hImageCopy = CreateCompatibleBitmap(hdc, pBmi->bmiHeader.biWidth, height);
		if (hImageCopy)
		{
			if (SetDIBits(hdc, hImageCopy, 0, height, pBits, pBmi, DIB_RGB_COLORS) == 0)
			{
				DeleteObject(hImageCopy);
				hImageCopy = NULL;
			}
		}
		DeleteDC(hdc);
	}
	GlobalFree(hDib);
*/
	if (hDib != NULL)
	{
		HANDLE hSysImage = SetClipboardData(CF_DIB, hDib);
		if (hSysImage != NULL)
		{
			if (m_openInIview && !m_iviewPath.IsEmpty())
			{
				STARTUPINFO startupInfo;
				memset(&startupInfo, 0, sizeof(startupInfo));
				startupInfo.cb = sizeof(startupInfo);
				PROCESS_INFORMATION processInformation;
				CString cmdLine = "\"";
				cmdLine += m_iviewPath;
				cmdLine += "\" /clippaste";
				if (CreateProcess(NULL, (LPSTR)(LPCTSTR)cmdLine, NULL, NULL, FALSE, 0, NULL,
								  NULL, &startupInfo, &processInformation) == 0)
					MessageBox("Failed to launch IrfanView");
			}
		}
		else
			MessageBox("Failed to copy the region to the clipboard");
	}
	CloseClipboard();
}

void IViewCaptureDlg::OnSettings() 
{
	m_strIviewPath = m_iviewPath;
	m_bOpenInIview = m_openInIview;
	m_editSettingPath.EnableWindow(m_openInIview ? TRUE : FALSE);
	UpdateData(FALSE);
	ShowWindow(SW_RESTORE);
}

void IViewCaptureDlg::OnSettingOpenInIview() 
{
	UpdateData(TRUE);
	m_editSettingPath.EnableWindow(m_bOpenInIview ? TRUE : FALSE);
}

void IViewCaptureDlg::OnSettingBrowse() 
{
	CFileDialog dlg(TRUE, _T("exe"), _T("i_view32.exe"), 
					OFN_FILEMUSTEXIST | OFN_PATHMUSTEXIST | OFN_HIDEREADONLY);

	TCHAR filename[MAX_PATH + 1];
	filename[0] = _T('\0');
	dlg.m_ofn.lpstrFile = filename;
	dlg.m_ofn.nMaxFile = MAX_PATH;
	
	if(dlg.DoModal() == IDOK)
	{
		m_strIviewPath = dlg.GetPathName();
		UpdateData(FALSE);
	}
}

void IViewCaptureDlg::OnCancel() 
{
	m_strIviewPath = m_iviewPath;
	m_bOpenInIview = m_openInIview;
	m_editSettingPath.EnableWindow(m_openInIview ? TRUE : FALSE);
	UpdateData(FALSE);
	ShowWindow(SW_SHOWMINIMIZED);
	ShowWindow(SW_HIDE);
}

void IViewCaptureDlg::OnOK() 
{
	UpdateData(TRUE);
	if (!IsSettingsOk())
		return;
	m_openInIview = m_bOpenInIview;
	m_iviewPath = m_strIviewPath;
	AfxGetApp()->WriteProfileInt("Settings", "OpenInIview", m_openInIview);
	AfxGetApp()->WriteProfileString("Settings", "IviewPath", (LPCTSTR)m_iviewPath);
	ShowWindow(SW_SHOWMINIMIZED);
	ShowWindow(SW_HIDE);
}

bool IViewCaptureDlg::IsSettingsOk()
{
	if (!m_bOpenInIview)
		return true;

	if (m_strIviewPath.IsEmpty())
	{
		MessageBox("Path to IrfanView is not set");
		m_editSettingPath.SetFocus();
		return false;
	}
	DWORD dwAttr = GetFileAttributes((LPCTSTR)m_strIviewPath);
	if (dwAttr == -1 /*INVALID_FILE_ATTRIBUTES*/)
	{
		MessageBox("Please point to an existing file");
		m_editSettingPath.SetFocus();
		return false;
	}
	if ((dwAttr & FILE_ATTRIBUTE_DIRECTORY) != 0)
	{
		MessageBox("Please point to an executable file, not to a folder");
		m_editSettingPath.SetFocus();
		return false;
	}
	return true;
}
